package com.company.ficons.component;

import com.google.common.base.Strings;
import com.vaadin.flow.component.details.Details;
import com.vaadin.flow.component.html.Div;
import com.vaadin.flow.component.html.Span;
import com.vaadin.flow.component.icon.Icon;
import com.vaadin.flow.component.icon.IconFactory;
import com.vaadin.flow.router.RouterLink;
import io.jmix.flowui.component.main.JmixListMenu;

public class ExtJmixListMenu extends JmixListMenu {

    public void addIconToMenuItem(String id, IconFactory iconFactory) {
        MenuItem menuItem = getMenuItem(id);

        if (menuItem instanceof MenuBarItem) {
            Details menuBarComponent = getMenuBarComponent(menuItem);
            Span summary = (Span) menuBarComponent.getSummary();

            Icon icon = iconFactory.create();
            icon.addClassName(MENUBAR_ICON_CLASS_NAME);

            Div div = new Div();
            div.add(icon, summary);
            div.addClassName(JMIX_MENUBAR_SUMMARY_ICON_CONTAINER_CLASS_NAME);
            div.setTitle(Strings.nullToEmpty(menuItem.getDescription()));
            menuBarComponent.setSummary(div);

        } else {
            RouterLink menuItemComponent = getMenuItemComponent(menuItem);
            Icon icon = iconFactory.create();
            icon.addClassName(LINK_ICON_CLASS_NAME);
            menuItemComponent.addComponentAsFirst(icon);
        }
    }
}
